﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Phone推送通知.Resources;
using Microsoft.Phone.Notification;
using System.Text;

namespace Phone推送通知
{
    public partial class MainPage : PhoneApplicationPage
    {
        // 构造函数
        public MainPage()
        {
            InitializeComponent();

        }

        //磁贴通知
        private void TileInit()
        {
            //推送服务通道
            HttpNotificationChannel pushChannel;

            //通道名称
            string channelName = "TileSampleChannel";

            InitializeComponent();

            //尝试发现是否已经创建
            pushChannel = HttpNotificationChannel.Find(channelName);

            var newChannel = false;
            //没有发现，新建一个
            if (pushChannel == null)
            {
                pushChannel = new HttpNotificationChannel(channelName);
                newChannel = true;
            }

            //通知通道关联URI改变时：
            pushChannel.ChannelUriUpdated += new EventHandler<NotificationChannelUriEventArgs>(PushChannel_ChannelUriUpdated);
            //出错时：
            pushChannel.ErrorOccurred += new EventHandler<NotificationChannelErrorEventArgs>(PushChannel_ErrorOccurred);

            if (newChannel)
            {
                pushChannel.Open();
                //将通知订阅绑定到默认图块
                pushChannel.BindToShellTile();
            }
            else
            {
                MessageBox.Show(String.Format("通道URI： {0}", pushChannel.ChannelUri.ToString()));
            }
        }

        //Toast通知
        private void ToastInit()
        {
            //推送服务通道
            HttpNotificationChannel pushChannel;

            //通道名称
            string channelName = "ToastSampleChannel";

            InitializeComponent();

            //尝试发现是否已经创建
            pushChannel = HttpNotificationChannel.Find(channelName);

            var newChannel = false;
            //没有发现，新建一个
            if (pushChannel == null)
            {
                pushChannel = new HttpNotificationChannel(channelName);
                newChannel = true;
            }

            //通知通道关联URI改变时：
            pushChannel.ChannelUriUpdated += new EventHandler<NotificationChannelUriEventArgs>(PushChannel_ChannelUriUpdated);
            //出错时：
            pushChannel.ErrorOccurred += new EventHandler<NotificationChannelErrorEventArgs>(PushChannel_ErrorOccurred);

            //收到Toast消息时：（如果程序未启动则弹出Toast，否则触发该事件）
            pushChannel.ShellToastNotificationReceived += new EventHandler<NotificationEventArgs>(PushChannel_ShellToastNotificationReceived);

            if (newChannel)
            {
                pushChannel.Open();
                //将通知订阅绑定到ShellToast
                pushChannel.BindToShellToast();
            }
            else
            {
                MessageBox.Show(String.Format("通道URI： {0}", pushChannel.ChannelUri.ToString()));
            }
        }

        //Row通知
        private void RawInit()
        {
            //推送服务通道
            HttpNotificationChannel pushChannel;

            //通道名称
            string channelName = "RawSampleChannel";

            InitializeComponent();

            //尝试发现是否已经创建
            pushChannel = HttpNotificationChannel.Find(channelName);

            var newChannel = false;
            //没有发现，新建一个
            if (pushChannel == null)
            {
                pushChannel = new HttpNotificationChannel(channelName);
                newChannel = true;
            }

            //通知通道关联URI改变时：
            pushChannel.ChannelUriUpdated += new EventHandler<NotificationChannelUriEventArgs>(PushChannel_ChannelUriUpdated);
            //出错时：
            pushChannel.ErrorOccurred += new EventHandler<NotificationChannelErrorEventArgs>(PushChannel_ErrorOccurred);

            //收到Raw通知时：（只有应用运行时才触发本事件）
            pushChannel.HttpNotificationReceived += new EventHandler<HttpNotificationEventArgs>(PushChannel_HttpNotificationReceived);


            if (newChannel)
            {
                pushChannel.Open();
                //这里并没有绑定操作
            }
            else
            {
                MessageBox.Show(String.Format("通道URI： {0}", pushChannel.ChannelUri.ToString()));
            }
        }


        //URI更新时
        void PushChannel_ChannelUriUpdated(object sender, NotificationChannelUriEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
            {
                MessageBox.Show(String.Format("通道URI： {0}", e.ChannelUri.ToString()));
            });
        }

        //遇到错误时
        void PushChannel_ErrorOccurred(object sender, NotificationChannelErrorEventArgs e)
        {
            //处理错误
        }

        //收到Toast通知时
        void PushChannel_ShellToastNotificationReceived(object sender, NotificationEventArgs e)
        {
            StringBuilder message = new StringBuilder();
            string relativeUri = string.Empty;

            message.AppendFormat("收到 Toast {0}:\n", DateTime.Now.ToShortTimeString());
            foreach (string key in e.Collection.Keys)
            {
                message.AppendFormat("{0}: {1}\n", key, e.Collection[key]);
                if (key.ToLower() == "wp:param") relativeUri = e.Collection[key];
            }
            Dispatcher.BeginInvoke(() => MessageBox.Show(message.ToString()));
        }

        //收到Raw通知时：
        void PushChannel_HttpNotificationReceived(object sender, HttpNotificationEventArgs e)
        {
            string message;

            using (System.IO.StreamReader reader = new System.IO.StreamReader(e.Notification.Body))
            {
                message = reader.ReadToEnd();
            }

            Dispatcher.BeginInvoke(() =>
                MessageBox.Show(String.Format("收到 Row {0}:\n{1}",
                    DateTime.Now.ToShortTimeString(), message))
                    );
        }


    }
}