﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Web服务端
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
        }



        //发送磁贴消息
        private void SendTile()
        {
            try
            {

                string subscriptionUri = TextBoxUri.Text.ToString();

                HttpWebRequest httpWebRequest = (HttpWebRequest)WebRequest.Create(subscriptionUri);
                httpWebRequest.Method = "POST";

                string tileMessage = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                "<wp:Notification xmlns:wp=\"WPNotification\">" +
                    "<wp:Tile>" +
                      "<wp:BackgroundImage>/Assets/Tiles/FlipCycleTileMedium.png</wp:BackgroundImage>" +
                      "<wp:Count>5</wp:Count>" +
                      "<wp:Title>标题</wp:Title>" +
                      "<wp:BackBackgroundImage></wp:BackBackgroundImage>" +
                      "<wp:BackTitle>背面标题</wp:BackTitle>" +
                      "<wp:BackContent>背面文本内容</wp:BackContent>" +
                   "</wp:Tile> " +
                "</wp:Notification>";

                byte[] notificationMessage = Encoding.Default.GetBytes(tileMessage);

                httpWebRequest.ContentLength = notificationMessage.Length;
                httpWebRequest.ContentType = "text/xml";
                //X-WindowsPhone-Target设置为token
                httpWebRequest.Headers.Add("X-WindowsPhone-Target", "token");
                //Tile消息类型为 1
                httpWebRequest.Headers.Add("X-NotificationClass", "1");


                using (Stream requestStream = httpWebRequest.GetRequestStream())
                {
                    requestStream.Write(notificationMessage, 0, notificationMessage.Length);
                }

                HttpWebResponse response = (HttpWebResponse)httpWebRequest.GetResponse();
                string notificationStatus = response.Headers["X-NotificationStatus"];
                string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
                string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];


            }
            catch (Exception ex)
            {
            }
        }

        //发送Toast消息
        private void SendToast()
        {
            try
            {
                //这个URI就是通道创建时由WP客户端获取到的，需要提交到服务端
                string uri = TextBoxUri.Text.ToString();

                HttpWebRequest httpWebRequest = (HttpWebRequest)WebRequest.Create(uri);
                httpWebRequest.Method = "POST";

                string toastMessage = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                "<wp:Notification xmlns:wp=\"WPNotification\">" +
                   "<wp:Toast>" +
                        "<wp:Text1>标题</wp:Text1>" +
                        "<wp:Text2>内容部分</wp:Text2>" +
                        "<wp:Param>/Page2.xaml?NavigatedFrom=ToastNotification</wp:Param>" +
                   "</wp:Toast> " +
                "</wp:Notification>";

                byte[] notificationMessage = Encoding.Default.GetBytes(toastMessage);

                //设置请求头
                httpWebRequest.ContentLength = notificationMessage.Length;
                httpWebRequest.ContentType = "text/xml";
                //X-WindowsPhone-Target设置为toast
                httpWebRequest.Headers.Add("X-WindowsPhone-Target", "toast");
                //Toast消息类型为 2
                httpWebRequest.Headers.Add("X-NotificationClass", "2");

                using (Stream requestStream = httpWebRequest.GetRequestStream())
                {
                    requestStream.Write(notificationMessage, 0, notificationMessage.Length);
                }

                HttpWebResponse response = (HttpWebResponse)httpWebRequest.GetResponse();
                //获取相应头包含的状态信息
                string notificationStatus = response.Headers["X-NotificationStatus"];
                string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
                string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];

            }
            catch (Exception ex)
            {
            }
        }

        //发送Raw消息
        private void SendRaw()
        {
            try
            {

                string subscriptionUri = TextBoxUri.Text.ToString();

                HttpWebRequest httpWebRequest = (HttpWebRequest)WebRequest.Create(subscriptionUri);
                httpWebRequest.Method = "POST";

                //这里的消息内容完全自定义，也可以为非xml
                string rawMessage = "<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                                "<root>" +
                                    "<Value1>a<Value1>" +
                                    "<Value2>b<Value2>" +
                                "</root>";

                byte[] notificationMessage = Encoding.Default.GetBytes(rawMessage);

                httpWebRequest.ContentLength = notificationMessage.Length;
                httpWebRequest.ContentType = "text/xml";
                //没有 X-WindowsPhone-Target 头
                //Raw消息类型为 3
                httpWebRequest.Headers.Add("X-NotificationClass", "3");

                using (Stream requestStream = httpWebRequest.GetRequestStream())
                {
                    requestStream.Write(notificationMessage, 0, notificationMessage.Length);
                }

                HttpWebResponse response = (HttpWebResponse)httpWebRequest.GetResponse();
                string notificationStatus = response.Headers["X-NotificationStatus"];
                string notificationChannelStatus = response.Headers["X-SubscriptionStatus"];
                string deviceConnectionStatus = response.Headers["X-DeviceConnectionStatus"];


            }
            catch (Exception ex)
            {
            }
        }


    }
}